#ifndef INC_DCF_CLOCK_H
#define INC_DCF_CLOCK_H

#include <stdint.h>
#include <stdio.h>
#include <avr/pgmspace.h>

#define DCFSIGNAL_DDR DDRD
#define DCFSIGNAL_PORT PIND
#define DCFSIGNAL_PIN PIND2

#define DCFPOWER_DDR DDRD
#define DCFPOWER_PORT PORTD
#define DCFPOWER_PIN PD3

#define OUT_PORT_DDR DDRC
#define OUT_PORT PORTC
#define OUT_PIN0 PC0
#define OUT_PIN1 PC1
#define OUT_PIN2 PC2
#define OUT_PIN3 PC3
#define OUT_PIN4 PC4
#define OUT_PIN5 PC5



/////////////
//Variables//
/////////////

 //date
 uint8_t week_day;
 uint8_t day;
 uint8_t month;
 uint16_t year;

 //time
 uint16_t millisecond;
 uint8_t second;
 uint8_t minute;
 uint8_t hour;
 uint8_t timezone;

 //Puffer für die int --> char Umwandlung
//  char itoa_buffer[8];
 extern char s[5];

 //Variables for checking stuff
 extern volatile uint8_t zonenmarke1;
 extern volatile uint8_t zonenmarke2;
 extern volatile uint8_t time_set_at_least_once;
 extern volatile uint8_t time_updated_today;
 extern volatile uint8_t start_dcf_sync;


 void leading_0(uint8_t digit);

#endif /*INC_DCF_CLOCK_H*/