#include "dcf.h"
#include "lcd-routines.h"
#include "lcd_highlevelfunctions.h"

volatile uint8_t successful_runs=0;
volatile uint8_t dcf_synced=0;
volatile uint8_t dcf_minute_check=0;
volatile uint8_t dcf_hour_check=0;
volatile uint8_t dcf_day_check=0;
volatile uint8_t dcf_month_check=0;
volatile uint8_t dcf_year_check=0;
/////////////////////////
//Function Declarations//
/////////////////////////
void dcf_0(void);
void dcf_1(void);


//////////////
//Read Level//
//////////////
void dcf_read_level(void)
{
  dataDCFPORT = DCFSIGNAL_PORT;//Der aktuelle Pegel vom DCF-Modul wird eingelesen und in dataDCFPORT den anderen Funktionen zur Verfügung gestellt
}

//////////////////////////////
//Counter & Reset-Funktionen//
//////////////////////////////
// void counter_highplusplus(void)
// {
//   counter_high++;
// }
//
// void counter_lowplusplus(void)
// {
//   counter_low++;
// }

void counter_reset(void)
{
	counter_low=0;
	counter_high=0;
	bit_number=0;
}

void dcf_date_reset(void)
{
	dcf_week_day=0;
	dcf_day=0;
	dcf_month=0;
	dcf_year=0;
	dcf_date_parity=0;
}

void dcf_time_reset(void)
{
	dcf_minute=0;
	dcf_minute_parity=0;
	dcf_hour=0;
	dcf_hour_parity=0;
	dcf_timezone=0;
}

///////////////////////
//DCF-Synchronisation//
///////////////////////
//low-Pegel muß für 1700-1900ms anliegen
//Danach muß ein high-Pegel folgen
void dcf_sync(void)
{
	dcf_synced=0;
	if (time_set_at_least_once==0) {show_matched_time(8,4);}
	DCFPOWER_PORT |= (1<<DCFPOWER_PIN);	// Modul einschalten

	if((dataDCFPORT & (1<<DCFSIGNAL_PIN)))
	{
		if(counter_low>=1750 && counter_low<=1950)
		{
// 			LCD-Ausgabe: Synchronisation erfolgreich
			dcf_synced=1;
			counter_reset();
			dcf_date_reset();
			dcf_time_reset();
			if(time_set_at_least_once==0){lcd_setcursor(0,1);lcd_string("Read");}
			else{lcd_setcursor(9,1);lcd_string("Read");}
		}
		else
		{
			counter_low=0;
			lcd_setcursor(14,1);lcd_string("h ");
			dcf_sync();
		}
	}
	else
	{
		lcd_setcursor(14,1);lcd_string(" l");
		dcf_sync();
	}
}

//////////////////
//DCF-Auswertung//
//////////////////
void dcf_0(void)
{
	switch(bit_number)
	{
		case 0: ;break;	//start einer neuen Minuten, muß immer 0 sein
		case 1: ;break;	//Wetterdaten
		case 2: ;break;	//Wetterdaten
		case 3: ;break;	//Wetterdaten
		case 4: ;break;	//Wetterdaten
		case 5: ;break;	//Wetterdaten
		case 6: ;break;	//Wetterdaten
		case 7: ;break;	//Wetterdaten
		case 8: ;break;	//Wetterdaten
		case 9: ;break;	//Wetterdaten
		case 10: ;break;	//Wetterdaten
		case 11: ;break;	//Wetterdaten
		case 12: ;break;	//Wetterdaten
		case 13: ;break;	//Wetterdaten
		case 14: ;break;	//Wetterdaten
		case 15: ;break;	//Rufbit für PTB
		case 16: ;break; //Keine Änderung der Zeitzone
		case 17: zonenmarke1=0;break;	//Zeitzone: dcf_timezone=dcf_timezone
		case 18: zonenmarke2=0;if(zonenmarke1==0){dcf_sync();}dcf_timezone+=1;break;	//Zeitzone:
		case 19: ;break;	//keine Schaltsekunde
		case 20: dcf_sync();break;	//Beginn der Zeitinformation (immer 1)
		case 21: ;break;
		case 22: ;break;
		case 23: ;break;
		case 24: ;break;
		case 25: ;break;
		case 26: ;break;
		case 27: ;break;
		case 28: ;break;	//Parität: Minute
		case 29: ;break;
		case 30: ;break;
		case 31: ;break;
		case 32: ;break;
		case 33: ;break;
		case 34: ;break;
		case 35: ;break;	//Parität: Stunde
		case 36: ;break;
		case 37: ;break;
		case 38: ;break;
		case 39: ;break;
		case 40: ;break;
		case 41: ;break;
		case 42: ;break;
		case 43: ;break;
		case 44: ;break;
		case 45: ;break;
		case 46: ;break;
		case 47: ;break;
		case 48: ;break;
		case 49: ;break;
		case 50: ;break;
		case 51: ;break;
		case 52: ;break;
		case 53: ;break;
		case 54: ;break;
		case 55: ;break;
		case 56: ;break;
		case 57: ;break;
		case 58: ;break;	//Parität: Datum
		case 59: dcf_sync();break;	//keine Absenkung --> neue Minute
		default: dcf_sync();break;
	}
}

void dcf_1(void)
{
	switch(bit_number)
	{
		case 0: dcf_sync();break;	//start einer neuen Minute, muß immer 0 sein
		case 1: ;break;	//Wetterdaten
		case 2: ;break;	//Wetterdaten
		case 3: ;break;	//Wetterdaten
		case 4: ;break;	//Wetterdaten
		case 5: ;break;	//Wetterdaten
		case 6: ;break;	//Wetterdaten
		case 7: ;break;	//Wetterdaten
		case 8: ;break;	//Wetterdaten
		case 9: ;break;	//Wetterdaten
		case 10: ;break;	//Wetterdaten
		case 11: ;break;	//Wetterdaten
		case 12: ;break;	//Wetterdaten
		case 13: ;break;	//Wetterdaten
		case 14: ;break;	//Wetterdaten
		case 15: ;break;	//Rufbit für PTB
		case 16: ;break; //Am Ende dieser Stunde wird auf MEZ/MESZ umgestellt
		case 17: zonenmarke1=1;dcf_timezone+=1;break;	//Zeitzone:
		case 18: zonenmarke2=1;if(zonenmarke1==1){dcf_sync();}break;	//Zeitzone: dcf_timezone=dcf_timezone
		case 19: ;break;	//Am Ende diese Stunde wird eine Schaltsekunde eingefügt.
		case 20: ;break;	//Beginn der Zeitinformation (immer 1)
		case 21: dcf_minute+=1;dcf_minute_parity+=1;break;
		case 22: dcf_minute+=2;dcf_minute_parity+=1;break;
		case 23: dcf_minute+=4;dcf_minute_parity+=1;break;
		case 24: dcf_minute+=8;dcf_minute_parity+=1;break;
		case 25: dcf_minute+=10;dcf_minute_parity+=1;break;
		case 26: dcf_minute+=20;dcf_minute_parity+=1;break;
		case 27: dcf_minute+=40;dcf_minute_parity+=1;break;
		case 28: dcf_minute_parity+=1;break;	//Parität: Minute
		case 29: dcf_hour+=1;dcf_hour_parity+=1;break;
		case 30: dcf_hour+=2;dcf_hour_parity+=1;break;
		case 31: dcf_hour+=4;dcf_hour_parity+=1;break;
		case 32: dcf_hour+=8;dcf_hour_parity+=1;break;
		case 33: dcf_hour+=10;dcf_hour_parity+=1;break;
		case 34: dcf_hour+=20;dcf_hour_parity+=1;break;
		case 35: dcf_hour_parity+=1;break;	//Parität: Stunde
		case 36: dcf_day+=1;dcf_date_parity+=1;break;
		case 37: dcf_day+=2;dcf_date_parity+=1;break;
		case 38: dcf_day+=4;dcf_date_parity+=1;break;
		case 39: dcf_day+=8;dcf_date_parity+=1;break;
		case 40: dcf_day+=10;dcf_date_parity+=1;break;
		case 41: dcf_day+=20;dcf_date_parity+=1;break;
		case 42: dcf_week_day+=1;dcf_date_parity+=1;break;
		case 43: dcf_week_day+=2;dcf_date_parity+=1;break;
		case 44: dcf_week_day+=4;dcf_date_parity+=1;break;
		case 45: dcf_month+=1;dcf_date_parity+=1;break;
		case 46: dcf_month+=2;dcf_date_parity+=1;break;
		case 47: dcf_month+=4;dcf_date_parity+=1;break;
		case 48: dcf_month+=8;dcf_date_parity+=1;break;
		case 49: dcf_month+=10;dcf_date_parity+=1;break;
		case 50: dcf_year+=1;dcf_date_parity+=1;break;
		case 51: dcf_year+=2;dcf_date_parity+=1;break;
		case 52: dcf_year+=4;dcf_date_parity+=1;break;
		case 53: dcf_year+=8;dcf_date_parity+=1;break;
		case 54: dcf_year+=10;dcf_date_parity+=1;break;
		case 55: dcf_year+=20;dcf_date_parity+=1;break;
		case 56: dcf_year+=40;dcf_date_parity+=1;break;
		case 57: dcf_year+=80;dcf_date_parity+=1;break;
		case 58: dcf_date_parity+=1;break;	//Parität: Datum
		case 59: dcf_sync();break;	//keine Absenkung --> neue Minute
		default: dcf_sync();break;
	}
}
/////////////////////////
//Berechnung Schaltjahr//
/////////////////////////
void leap_year(void)
{
	if(year%4==0 && year%100!=0)
	{
		leapyear=1;	//Schaltjahr, da durch 4 teilbar aber nicht durch 100
	}
	else
	{
		if(year%4!=0)
		{
			leapyear=0;//Kein Schaltjahr, da nicht durch 4 teilbar
		}
		else
		{
			if(year%400==0)
			{
				leapyear=1;//Schaltjahre, da durch 400 teilbar
			}
			else
			{
				leapyear=0;//Kein Schaltjahr, da durch 100 teilbar aber nicht durch 400
			}
		}
	}
}

////////////////////////////////////////////////////////
//Zusammenführung der internen Daten und der DCF-Daten//
////////////////////////////////////////////////////////
void match_date(void)
{
	week_day=dcf_week_day;
	day=dcf_day;
	month=dcf_month;
	year=2000+dcf_year;
}

void match_time(void)
{
	millisecond=0;
	second=0;
	minute=dcf_minute;
	hour=dcf_hour;
	timezone=dcf_timezone;
}

///////////////////////
//DCF-Pegelauswertung//
///////////////////////
void level_analysis(void)
{

	if(!(dataDCFPORT & (1<<DCFSIGNAL_PIN)))
	{
  lcd_setcursor(14,1);lcd_string(" l");
		if(counter_high>=60 && counter_high<=140)	//logisch 0
		{
// 			minute_frame[bit_number]=0;
			dcf_0();
			bit_number++;
			dcf_second++;
			counter_low=0;
			counter_high=0;
		}
		else
		{
			if(counter_high>=160 && counter_high<=240)	//logisch 1
			{
				//			minute_frame[bit_number]=1;
				dcf_1();
				bit_number++;
				counter_low=0;
				counter_high=0;
			}
			else
			{
				counter_high=0;
			}
		}
	}
	else
	{
		lcd_setcursor(14,1);lcd_string("h ");
		if(counter_low>=1750 && counter_low<=1950)
		{
			if(bit_number==59 && dcf_minute_parity%2==0 && dcf_hour_parity%2==0 && dcf_date_parity%2==0)
			{
				bit_number=0;
				dcf_minute_check++;		//Zusätzlicher Check: Es muss mehrmals in Folge eine gültige (Checksumme) zeit ermittelt werden
				if(dcf_minute_check==60)	//die zur zeit aus der Runde davor passt
				{
					dcf_minute_check=0;dcf_hour_check++;
					if(dcf_hour_check==24)
					{
						dcf_hour_check=0;
					}
				}
				if(successful_runs==0) //Prüfrunde neu gestartet: Vergleich mit voriger Runde TRUE
				{
					dcf_minute_check=dcf_minute; dcf_hour_check=dcf_hour;
				}
				if((dcf_minute_check==dcf_minute) && (dcf_hour_check==dcf_hour))
				{
					successful_runs++;
					lcd_setcursor(15,3);lcd_data(' ');
					if(successful_runs==3)
					{
						successful_runs=255;
						match_date();
						match_time();
						time_updated_today=1;
						time_set_at_least_once=1;
						DCFPOWER_PORT &= ~(1<<DCFPOWER_PIN); // Modul ausschalten
						lcd_setstandardtext(); // Ausgabe setzen
					}
				}
				else
				{
					dcf_minute_check=dcf_minute; dcf_hour_check=dcf_hour;
					lcd_setcursor(15,3);lcd_data('F');
					successful_runs=0;
				}
			}
			else
			{
				successful_runs=0;
				dcf_date_reset();
				dcf_time_reset();
				counter_low=0;
				lcd_setcursor(15,3);lcd_data('E');
// 				dcf_sync();
				start_dcf_sync=1;
			}
			counter_low=0;
			dcf_date_reset();
			dcf_time_reset();
			switch(successful_runs)
			{
				case 0: lcd_setcursor(15,3);lcd_data('0'); break;
				case 1: lcd_setcursor(15,3);lcd_data('1'); break;
				case 2: lcd_setcursor(15,3);lcd_data('2'); break;
				default: break;
			}
			if (successful_runs==255){successful_runs=0;}
		}
	}
}