#ifndef INC_DCF_H 
#define INC_DCF_H 

#include <stdint.h>

/////////////
//Variables//
/////////////



//Speicherbereich für DCF-Pegel
uint8_t dataDCFPORT;

//Pegel-Auswertung
uint16_t counter_low;
uint16_t counter_high;
uint8_t bit_number;

//dcf_date
uint8_t dcf_week_day;
uint8_t dcf_day;
uint8_t dcf_month;
uint8_t dcf_year;
uint8_t dcf_date_parity;

//dcf_time
uint8_t dcf_second;
uint8_t dcf_minute;
uint8_t dcf_minute_parity;
uint8_t dcf_hour;
uint8_t dcf_hour_parity;
uint8_t dcf_timezone;

//Schaltjahr
uint8_t leapyear;



//////////////
//Read Level//
//////////////
void dcf_read_level(void);


//////////////////////////////
//Counter & Reset-Funktionen//
//////////////////////////////
// void counter_highplusplus(void);
// void counter_lowplusplus(void);
void counter_reset(void);
void dcf_date_reset(void);
void dcf_time_reset(void);

///////////////////////
//DCF-Synchronisation//
///////////////////////
void dcf_sync(void);

/////////////////////////
//Berechnung Schaltjahr//
/////////////////////////
void leap_year(void);

////////////////////////////////////////////////////////
//Zusammenführung der internen Daten und der DCF-Daten//
////////////////////////////////////////////////////////
void match_date(void);
void match_time(void);
void level_analysis(void);

#endif	/*INC_DCF_H */