////////////////
//LCD-Ausgaben//
////////////////
#include "lcd_highlevelfunctions.h"

//Zusammengeführtes Datum
void show_matched_date(uint8_t column,uint8_t row)	//Übergabe der Cursorposition (Spalte,Zeile)
{
	lcd_setcursor(column,row);

	//LCD-Ausgabe: Wochentag
	switch(week_day)
	{
		case 1: lcd_string("Mo  ");break;	//LCD-Ausgabe: Montag
		case 2: lcd_string("Di  ");break;	//LCD-Ausgabe: Dienstag
		case 3: lcd_string("Mi  ");break;	//LCD-Ausgabe: Mittwoch
		case 4: lcd_string("Do  ");break;	//LCD-Ausgabe: Donnerstag
		case 5: lcd_string("Fr  ");break;	//LCD-Ausgabe: Freitag
		case 6: lcd_string("Sa  ");break;	//LCD-Ausgabe: Samstag
		case 7: lcd_string("So  ");break;	//LCD-Ausgabe: Sonntag
		default: lcd_string("   ");break;
	}

	//LCD-Ausgabe: Tag
	leading_0(day);
// 	itoa(day,itoa_buffer,10);
// 	lcd_string(itoa_buffer);
	snprintf(s,4,"%d",day);
	lcd_string(s);
	lcd_data('.');

	//LCD-Ausgabe: Monat
	leading_0(month);
// 	itoa(month,itoa_buffer,10);
// 	lcd_string(itoa_buffer);
	snprintf(s,4,"%d",month);
	lcd_string(s);
	lcd_string(".");

	//LCD-Ausgabe: Jahreszahl
	leading_0(year);
// 	itoa(year,itoa_buffer,10);
// 	lcd_string(itoa_buffer);
	snprintf(s,5,"%d",year);
	lcd_string(s);
}

//Zusammengeführte Zeit
void show_matched_time(uint8_t column,uint8_t row)	//Übergabe der Cursorposition (Spalte,Zeile)
{
	lcd_setcursor(column,row);

	//LCD-Ausgabe: Stunde
	leading_0(hour);
// 	itoa(hour,itoa_buffer,10);
// 	lcd_string(itoa_buffer);
	snprintf(s,4,"%d",hour);
	lcd_string(s);
	lcd_data(':');

	//LCD-Ausgabe: Minute
	leading_0(minute);
// 	itoa(minute,itoa_buffer,10);
// 	lcd_string(itoa_buffer);
	snprintf(s,4,"%d",minute);
	lcd_string(s);
	lcd_data(':');

	//LCD-Ausgabe: Sekunde
	leading_0(second);
// 	itoa(second,itoa_buffer,10);
// 	lcd_string(itoa_buffer);
	snprintf(s,4,"%d",second);
	lcd_string(s);
	lcd_data(' ');

	//LCD-Ausgabe: Zeitzone
	switch(timezone)
	{
		case 0: lcd_string(" MEZ ");break;	//Ausgabe: Mitteleuropäische Zeit
		case 2: lcd_string(" MESZ");break;	//Ausgabe: Mitteleuropäische Sommerzeit
		default: lcd_string(" NOTZ");break;	//"No timezone"(NOTZ): Bitfehler bei der Auswertung der Zeitzone
	}
}

//Standardanzeige setzen
void lcd_setstandardtext(void)
{
	lcd_setcursor(0,1);
	lcd_string("Light           ");
	lcd_setcursor(0,2);
	lcd_string("                ");
	lcd_setcursor(0,3);
	lcd_string("                ");
// 	show_matched_time(8,4);
// 	lcd_setcursor(0,4);
// 	lcd_string("Synced");
}

//Anzeige beim ersten Start setzen
void lcd_setfirstsynctext(void)
{
	lcd_setcursor(0,1);
	lcd_string("Syncing Level:  ");
	lcd_setcursor(0,2);
	lcd_string("          Bit:  ");
	lcd_setcursor(0,3);
	lcd_string("         Runs:  "); //Pegel auf (15,1), Bit auf (15,2), Runs auf (15,3)
// 	lcd_setcursor(0,4);
// 	lcd_string("Uptime:");
}

//Anzeige beim Neuermitteln der Zeit setzen
void lcd_setresynctext(void)
{
	lcd_setcursor(0,1);
	lcd_string("Updating:Syncing");
	lcd_setcursor(0,2);
	lcd_string("                ");
	lcd_setcursor(0,3);
	lcd_string(" time:          "); //Pegel auf (15,1), Bit auf (15,2), Runs auf (15,3)
	lcd_setcursor(0,4);
	lcd_string("                ");
}

//Status der Ausgänge anzeigen
void lcd_updatestatus(uint8_t channel, uint8_t status)
{
// 	if(time_updated_today==0){channel=channel+128;};
	switch(channel)
	{
		case   0: lcd_setcursor(7,1);break;
		case   1: lcd_setcursor(12,1);break;
// 		case   2: lcd_setcursor(0,0);break;
		case 128: lcd_setcursor(3,4);break;
		case 129: lcd_setcursor(10,4);break;
// 		case 130: lcd_setcursor(0,0);break;
		default:break;
	}
	switch(status)
	{
		case 0: lcd_string("OFF ");break;
		case 1: lcd_string("ON  ");break;
	}
}